function Phi=chanEsodoglu(R)
close all;
thresh  = 0.5;
I       = double(imread('image.pgm'))/255;
[m,n]   = size(I);
center  = floor([m/2 n/2]);
[X, Y]  = meshgrid(1:m,1:n);
u       = projection(R - sqrt((X-center(1)).^2 + (Y-center(2)).^2));
figure; colormap gray;
loop = true;
for i=1:500
    du = update(u,I);
    u  = projection(u+0.01*du);
    imagesc(u>thresh); axis equal; drawnow;
    fprintf('Iteration: %d\n',i);

end
imagesc(u>thresh);axis equal;

return;


function [mu1,mu2] = approxRegions(u,I)
mu1 = mean(I(u>0.5));
mu2 = mean(I(u<0.5));
return;


function du = update(u,I)
eps   = 1e-1;
nu    = 2;
ux    =dxp(u);
uy    =dyp(u);

scale = 1./sqrt(ux.^2+uy.^2+eps^2);

ux    = ux.*scale;
uy    = uy.*scale;
uxx   =dxm(ux);
uyy   =dym(uy);
[mu1, mu2] = approxRegions(u,I);
du   = nu*(uxx+uyy)-(I-mu1).^2+(I-mu2).^2;
return;


function u = projection(f)
u=f;
u((u>1))=1;
u((u<0))=0;
return;
